grammar Task;

import EquationRules;

/*
 * Parser Rules
 */

task   : task_eq lemma_tasks? task_lemmata? EOF ;

task_eq: 'task' eq ind_var? config ;

lemma_tasks : 'proof lemmata' lemma_task+ ;
lemma_task  : BEZ ':' eq ind_var? config ;

task_lemmata: 'lemmata' task_lemma+ ;
task_lemma  : BEZ ':' eq ;

ind_var     : 'induction' BEZ ;

config      : (task_pt | ind_pt) ;

ind_pt      : case_pt+ ih_pt ;
case_pt     : 'case' BEZ task_pt ;
ih_pt       : 'IH' maxpt ;

task_pt     : maxpt minsteps maxsteps ;
maxpt       : ('maxpt' | 'maxPt') NAT ;
minsteps    : 'minsteps' NAT ;
maxsteps    : 'maxsteps' NAT ;