﻿using System.Collections.Generic;

namespace Eingabeverwaltung.Metamodell
{
	public class InductionCase : Ueberpruefung.Element
	{
		public readonly string type;
		public readonly Equation eq;
		public readonly List<Variable> fixedVars;
		public readonly Transformation proof;
		public readonly List<Error> errors;
		private Constructor constructor;
		private List<Variable> buildingParameterVariables;

		public InductionCase(string type, Equation eq, List<Variable> fixedVars, Transformation proof)
		{
			this.type = type;
			this.fixedVars = fixedVars;
			this.eq = eq;
			this.proof = proof;
			errors = new List<Error>();
			constructor = null;
			buildingParameterVariables = null;
		}

		public Constructor Constructor
		{
			get { return constructor; }
			set { if (constructor == null) constructor = value; else throw new System.Exception("Tried to reset constructor in InductionCase!"); }
		}
		public List<Variable> BuildingParameterVariables
		{
			get { return buildingParameterVariables; }
			set { if (buildingParameterVariables == null) buildingParameterVariables = value; 
				  else throw new System.Exception("Tried to reset buildingParameterVariables in InductionCase!"); 
			}
		}

		public string ToString(bool showMetadata)
        {
			string res = new TaskLemma(type, eq, fixedVars).ToString();
			if (showMetadata && constructor != null) res += "case: " + constructor.name + "\r\n";
			res += proof.ToString(showMetadata);
			return res;
		}
    }
}
