﻿using System;
using System.Collections.Generic;
using Ueberpruefung;

namespace Eingabeverwaltung.Metamodell
{
	public class Substitution : Element
	{
		public readonly string      variableName;
		public readonly Variable    variable;
		public readonly Tree        tree;
		public readonly List<Error> errors;

		/// <summary>
		/// This Constructor throws Exception if variable is null.
		/// </summary>
		/// <param name="variable"></param>
		/// <param name="tree"></param>
		public Substitution(Variable variable, Tree tree)
		{
			if (variable == null) throw new Exception("Error: It was tried to build a Substitution with a null-variable and without variableName!");
			variableName = variable.name;
			this.variable = variable;
			this.tree = tree;
			errors = new List<Error>();
		}

		/// <summary>
		/// This Constructor allows the variable to be null. It means, that it don't exists in the variables of the ADT.
		/// </summary>
		/// <param name="variableName"></param>
		/// <param name="variable"></param>
		/// <param name="tree"></param>
		public Substitution(string variableName, Variable variable, Tree tree)
		{
			this.variableName = variableName;
			this.variable = variable;
			this.tree = tree;
			errors = new List<Error>();
		}

		public override string ToString()
		{
			string res = tree.ToString() + " / ";
			if (variable != null) res += variable.Name() + " "; else res += "n.d.(" + variableName + ") ";
			return res;
		}

	}
}
