﻿
using System.Collections.Generic;

namespace Eingabeverwaltung.Metamodell
{
    public class SingleTask : Rule
    {
        public readonly List<Variable> fixedVars;
        public readonly IConfig config;
        public readonly Variable indVariable;

        public SingleTask(string name, Equation eq, List<Variable> fixedVars, IConfig config, Variable indVariable) : base(name, eq)
        {
            this.fixedVars = fixedVars;
            this.config = config;
            this.indVariable = indVariable;
        }

        public override bool IsFixed(Variable variable) => fixedVars.Contains(variable);

        public string ToString(bool showConfig)
        {
            string res = base.ToString();
            if (indVariable != null) res += "  induction " + indVariable.name + "\r\n";
            if ( showConfig ) res += "    " + config.ToString();
            return res;
        }
    }
}
